## timew 1.4.3+ds.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)
set (CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
set (HAVE_CMAKE true)

project (timew)
include (CXXSniffer)
include (FindAsciidoctor)

set (PROJECT_VERSION "1.4.3")

string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)

message ("-- Looking for SHA1 references")
if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)
  set (HAVE_COMMIT true)
  execute_process (COMMAND git log -1 --pretty=format:%h
                   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                   OUTPUT_VARIABLE COMMIT)
  configure_file ( ${CMAKE_SOURCE_DIR}/commit.h.in
                   ${CMAKE_SOURCE_DIR}/commit.h)
  message ("-- Found SHA1 reference: ${COMMIT}")
endif (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)

set (PACKAGE "${PROJECT_NAME}")
set (VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "support@gothenburgbitfactory.org")
set (PACKAGE_NAME "${PACKAGE}")
set (PACKAGE_TARNAME "${PACKAGE}")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_STRING "${PACKAGE} ${VERSION}")
string (TIMESTAMP PACKAGE_DATE "%Y-%m-%d")

if (FREEBSD OR DRAGONFLY)
SET (TIMEW_MANDIR  man      CACHE STRING "Installation directory for man pages")
SET (TIMEW_MAN1DIR man/man1 CACHE STRING "Installation directory for man pages, section 1")
SET (TIMEW_MAN5DIR man/man5 CACHE STRING "Installation directory for man pages, section 5")
SET (TIMEW_MAN7DIR man/man7 CACHE STRING "Installation directory for man pages, section 7")
else (FREEBSD OR DRAGONFLY)
SET (TIMEW_MANDIR  share/man      CACHE STRING "Installation directory for man pages")
SET (TIMEW_MAN1DIR share/man/man1 CACHE STRING "Installation directory for man pages, section 1")
SET (TIMEW_MAN5DIR share/man/man5 CACHE STRING "Installation directory for man pages, section 5")
SET (TIMEW_MAN7DIR share/man/man7 CACHE STRING "Installation directory for man pages, section 7")
endif (FREEBSD OR DRAGONFLY)
SET (TIMEW_DOCDIR  share/doc/timew CACHE STRING "Installation directory for doc files")

message ("-- Configuring cmake.h")
configure_file (
  ${CMAKE_SOURCE_DIR}/cmake.h.in
  ${CMAKE_SOURCE_DIR}/cmake.h)

add_subdirectory (src)
add_subdirectory (src/commands)
add_subdirectory (doc)
add_subdirectory (ext)
if (EXISTS ${CMAKE_SOURCE_DIR}/test)
  add_subdirectory (test EXCLUDE_FROM_ALL)
endif (EXISTS ${CMAKE_SOURCE_DIR}/test)

set (doc_FILES ChangeLog README.md INSTALL AUTHORS LICENSE)
foreach (doc_FILE ${doc_FILES})
  install (FILES ${doc_FILE}  DESTINATION ${TIMEW_DOCDIR})
endforeach (doc_FILE)

# ---

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION})
set (CPACK_SOURCE_IGNORE_FILES  "CMakeCache" "CMakeFiles" "CPackConfig" "CPackSourceConfig"
                                "_CPack_Packages" "cmake_install" "install_manifest" "Makefile$"
                                "test" "package-config" "src/timew$" "src/libtimew.a"
                                "src/commands/libcommands.a" "src/lex$" "src/liblibshared.a"
                                "/\\\\.gitignore" "/\\\\.git/" "swp$")
include (CPack)

=== doc/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

message ("-- Configuring documentation")

add_subdirectory (holidays)
add_subdirectory (themes)

if (ASCIIDOCTOR_FOUND)
  set (ASCIIDOCTOR_OPTIONS "--attribute=manmanual=User Manuals"
                           "--attribute=mansource=timew ${PROJECT_VERSION}"
                           "--attribute=man-linkstyle='pass:[blue R < >]'")

  add_subdirectory (man1)
  add_subdirectory (man7)

  add_custom_target (doc ALL DEPENDS man1 man7)
else (ASCIIDOCTOR_FOUND)
  add_custom_target (doc ALL
                     COMMAND echo "Tool 'asciidoctor' is required to generate man pages! Please install it first.")
endif (ASCIIDOCTOR_FOUND)

=== ext/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

message ("-- Configuring extensions")

install (FILES on-modify.timewarrior totals.py DESTINATION ${TIMEW_DOCDIR}/ext)

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/libshared/src
                     ${TIMEW_INCLUDE_DIRS})

set (timew_SRCS AtomicFile.cpp AtomicFile.h
                CLI.cpp        CLI.h
                Chart.cpp      Chart.h
                               ChartConfig.h
                Database.cpp   Database.h
                Datafile.cpp   Datafile.h
                DatetimeParser.cpp DatetimeParser.h
                Exclusion.cpp  Exclusion.h
                Extensions.cpp Extensions.h
                Interval.cpp   Interval.h
                IntervalFactory.cpp IntervalFactory.h
                Journal.cpp    Journal.h
                Range.cpp      Range.h
                Rules.cpp      Rules.h
                TagInfo.cpp    TagInfo.h
                TagInfoDatabase.cpp TagInfoDatabase.h
                Transaction.cpp Transaction.h
                TransactionsFactory.cpp TransactionsFactory.h
                UndoAction.cpp UndoAction.h
                data.cpp
                dom.cpp
                init.cpp
                helper.cpp
                log.cpp
                util.cpp
                validate.cpp)

set (libshared_SRCS libshared/src/Args.cpp          libshared/src/Args.h
                    libshared/src/Color.cpp         libshared/src/Color.h
                    libshared/src/Composite.cpp     libshared/src/Composite.h
                    libshared/src/Configuration.cpp libshared/src/Configuration.h
                    libshared/src/Datetime.cpp      libshared/src/Datetime.h
                    libshared/src/Duration.cpp      libshared/src/Duration.h
                    libshared/src/FS.cpp            libshared/src/FS.h
                    libshared/src/JSON.cpp          libshared/src/JSON.h
                    libshared/src/Lexer.cpp         libshared/src/Lexer.h
                    libshared/src/Msg.cpp           libshared/src/Msg.h
                    libshared/src/Palette.cpp       libshared/src/Palette.h
                    libshared/src/Pig.cpp           libshared/src/Pig.h
                    libshared/src/RX.cpp            libshared/src/RX.h
                    libshared/src/Table.cpp         libshared/src/Table.h
                    libshared/src/Timer.cpp         libshared/src/Timer.h
                    libshared/src/format.cpp        libshared/src/format.h
                    libshared/src/shared.cpp        libshared/src/shared.h
                    libshared/src/unicode.cpp       libshared/src/unicode.h
                    libshared/src/utf8.cpp          libshared/src/utf8.h
                                                    libshared/src/wcwidth.h)

add_library (timew     STATIC ${timew_SRCS})
add_library (libshared STATIC ${libshared_SRCS})
add_executable (timew_executable timew.cpp)
add_executable (lex_executable   lex.cpp)

target_link_libraries (timew_executable timew libshared commands timew libshared ${TIMEW_LIBRARIES})
target_link_libraries (lex_executable   timew libshared                libshared ${TIMEW_LIBRARIES})

set_property (TARGET timew_executable PROPERTY OUTPUT_NAME "timew")
set_property (TARGET lex_executable   PROPERTY OUTPUT_NAME "lex")

install (TARGETS timew_executable DESTINATION bin)

=== test/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

# This is a work-around for the following CMake issue:
# https://gitlab.kitware.com/cmake/cmake/issues/16062
# The issue has been fixed in CMake 3.11.0; the policy is set
# to OLD for compatibility with older versions of CMake only.
if(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
  cmake_policy(SET CMP0037 OLD)
endif()

# If this is a debug build, check if we have libfiu installed and available on
# the system. If so, we will be able to use it to add additional tests of the
# failure conditions

if (uppercase_CMAKE_BUILD_TYPE MATCHES "DEBUG")
  find_library(FIU_ENABLE fiu) 
  if (FIU_ENABLE)
    message (STATUS "libfiu found")
    add_definitions (-DFIU_ENABLE)
    set (test_LIBS fiu ${TIMEW_LIBRARIES})
  else (FIU_ENABLE)
    message (STATUS "NOTE: install libfiu to run additional tests")
    set (test_LIBS ${TIMEW_LIBRARIES})
  endif (FIU_ENABLE)
else (uppercase_CMAKE_BUILD_TYPE MATCHES "DEBUG")
  set (test_LIBS ${TIMEW_LIBRARIES})
endif (uppercase_CMAKE_BUILD_TYPE MATCHES "DEBUG")

include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/libshared/src
                     ${CMAKE_SOURCE_DIR}/test)

include_directories (${CMAKE_INSTALL_PREFIX}/include)
link_directories(${CMAKE_INSTALL_PREFIX}/lib)

set (test_SRCS AtomicFileTest data.t Datafile.t DatetimeParser.t exclusion.t helper.t interval.t range.t rules.t util.t TagInfoDatabase.t)

add_custom_target (test ./run_all --verbose
                        DEPENDS ${test_SRCS} timew_executable doc
                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test)

foreach (src_FILE ${test_SRCS})
  add_executable (${src_FILE} "${src_FILE}.cpp" test.cpp)
  target_link_libraries (${src_FILE} timew libshared ${test_LIBS})
endforeach (src_FILE)

configure_file(run_all run_all COPYONLY)
configure_file(problems problems COPYONLY)

=== doc/holidays/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

message ("-- Configuring holiday documentation")

install (FILES README         DESTINATION ${TIMEW_DOCDIR}/doc/holidays)
install (FILES holidays.en-US DESTINATION ${TIMEW_DOCDIR}/doc/holidays)
install (FILES refresh        DESTINATION ${TIMEW_DOCDIR}/doc/holidays)

=== doc/man1/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

file (GLOB DOC_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/*.1.adoc")
set (DOC_FILES)

foreach (SRC ${DOC_SOURCES})
  string (REPLACE ".adoc" "" OUTPUT_FILE_NAME "${SRC}")

  add_custom_command (
          OUTPUT "${OUTPUT_FILE_NAME}"
          COMMAND ${ASCIIDOCTOR_EXECUTABLE} -b manpage ${ASCIIDOCTOR_OPTIONS} ${SRC} -o ${OUTPUT_FILE_NAME}
          DEPENDS "${SRC}")

  set (DOC_FILES ${DOC_FILES} "${OUTPUT_FILE_NAME}")
endforeach (SRC)

add_custom_target (man1 DEPENDS ${DOC_FILES})

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
         DESTINATION ${TIMEW_MANDIR}
         FILES_MATCHING PATTERN "*.1")

=== doc/man7/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

file (GLOB DOC_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/*.7.adoc")
set (DOC_FILES)

foreach (SRC ${DOC_SOURCES})
  string (REPLACE ".adoc" "" OUTPUT_FILE_NAME "${SRC}")

  add_custom_command (
          OUTPUT "${OUTPUT_FILE_NAME}"
          COMMAND ${ASCIIDOCTOR_EXECUTABLE} -b manpage ${ASCIIDOCTOR_OPTIONS} ${SRC} -o ${OUTPUT_FILE_NAME}
          DEPENDS "${SRC}")

  set (DOC_FILES ${DOC_FILES} "${OUTPUT_FILE_NAME}")
endforeach (SRC)

add_custom_target (man7 DEPENDS ${DOC_FILES})

install (DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
         DESTINATION ${TIMEW_MANDIR}
         FILES_MATCHING PATTERN "*.7")

=== src/commands/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/src/commands
                     ${CMAKE_SOURCE_DIR}/src/libshared/src
                     ${TIMEW_INCLUDE_DIRS})

set (ADDITIONAL_HELP_H "additional-help.h")

ADD_CUSTOM_COMMAND (
	OUTPUT ${ADDITIONAL_HELP_H}
	COMMAND /bin/sh src/commands/generate-additional-help.sh > src/commands/${ADDITIONAL_HELP_H}
	DEPENDS ${CMAKE_CURRENT_LIST_DIR}/generate-additional-help.sh
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
	COMMENT "Generating ${ADDITIONAL_HELP_H}")

ADD_CUSTOM_TARGET (generate_additional_help
									 DEPENDS ${ADDITIONAL_HELP_H})

set (commands_SRCS CmdAnnotate.cpp
                   CmdCancel.cpp
                   CmdChart.cpp
                   CmdConfig.cpp
                   CmdContinue.cpp
                   CmdDefault.cpp
                   CmdDelete.cpp
                   CmdDiagnostics.cpp
                   CmdExport.cpp
                   CmdExtensions.cpp
                   CmdFill.cpp
                   CmdGaps.cpp
                   CmdGet.cpp
                   CmdHelp.cpp
                   CmdJoin.cpp
                   CmdLengthen.cpp
                   CmdModify.cpp
                   CmdMove.cpp
                   CmdReport.cpp
                   CmdResize.cpp
                   CmdStart.cpp
                   CmdStop.cpp
                   CmdSummary.cpp
                   CmdShorten.cpp
                   CmdShow.cpp
                   CmdSplit.cpp
                   CmdTag.cpp
                   CmdTags.cpp
                   CmdTrack.cpp
                   CmdUndo.cpp
                   CmdUntag.cpp)

add_library (commands STATIC ${commands_SRCS})
add_dependencies (commands generate_additional_help)

=== src/libshared/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
set (CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
set (HAVE_CMAKE true)

project (shared)
include (CXXSniffer)

include (CheckFunctionExists)

set (PROJECT_VERSION "1.0.0")

set (PACKAGE "${PROJECT_NAME}")
set (VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "support@taskwarrior.org")
set (PACKAGE_NAME "${PACKAGE}")
set (PACKAGE_TARNAME "${PACKAGE}")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_STRING "${PACKAGE} ${VERSION}")

check_function_exists(strlcpy HAVE_STRLCPY)

message ("-- Configuring cmake.h")
configure_file (
  ${CMAKE_SOURCE_DIR}/cmake.h.in
  ${CMAKE_SOURCE_DIR}/cmake.h)

add_subdirectory (src)
if (EXISTS ${CMAKE_SOURCE_DIR}/test)
  add_subdirectory (test EXCLUDE_FROM_ALL)
endif (EXISTS ${CMAKE_SOURCE_DIR}/test)

=== src/libshared/src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src)

set (shared_HEADERS Args.h
                    Color.h
                    Composite.h
                    Configuration.h
                    Datetime.h
                    Duration.h
                    FS.h
                    JSON.h
                    Lexer.h
                    Log.h
                    Msg.h
                    Packrat.h
                    Palette.h
                    PEG.h
                    Pig.h
                    RX.h
                    Table.h
                    Timer.h
                    Tree.h
                    shared.h
                    format.h
                    unicode.h
                    utf8.h
                    wcwidth.h)

set (shared_SRCS Args.cpp
                 Color.cpp
                 Composite.cpp
                 Configuration.cpp
                 Datetime.cpp
                 Duration.cpp
                 FS.cpp
                 JSON.cpp
                 Lexer.cpp
                 Log.cpp
                 Msg.cpp
                 Packrat.cpp
                 Palette.cpp
                 PEG.cpp
                 Pig.cpp
                 RX.cpp
                 SAX.cpp
                 Table.cpp
                 Timer.cpp
                 Tree.cpp
                 format.cpp
                 ip.cpp
                 shared.cpp
                 unicode.cpp
                 utf8.cpp
                 ${shared_HEADERS})

add_library (shared STATIC ${shared_SRCS})

set (CMAKE_INSTALL_LIBDIR lib CACHE PATH "Output directory for libraries")
install (TARGETS shared DESTINATION lib)
install (FILES ${shared_HEADERS} DESTINATION include)

add_executable (lex_executable lex.cpp)
target_link_libraries (lex_executable shared)
set_property (TARGET lex_executable PROPERTY OUTPUT_NAME "lex")

=== debian/changelog ===
timew (1.4.3+ds.1-2) unstable; urgency=medium

  * Increase timeout for config steps in tests to try and avoid flaky
    autopkgtests. Patch by Travis Wrightsman. May address #1001668.

 -- Gordon Ball <gordon@chronitis.net>  Sun, 23 Oct 2022 22:38:14 +0200

timew (1.4.3+ds.1-1) unstable; urgency=medium

  * New upstream version 1.4.3+ds.1
  * Rebase patches, drop thread-is-alive (upstream)
  * Add build-depends on asciidoctor for man pages
  * Fix out-of-source build for manpages

 -- Gordon Ball <gordon@chronitis.net>  Wed, 27 Oct 2021 18:11:54 +0000

timew (1.4.2+ds.1-4) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * simplify a bit the uscan rule, using the recommended option from uscan

  [ Gordon Ball ]
  * d/watch: new github tarball URL
  * Debhelper compat 13
  * Standards-Version: 4.6.0

 -- Gordon Ball <gordon@chronitis.net>  Mon, 25 Oct 2021 17:43:55 +0000

=== debian/control ===
Source: timew
Section: utils
Priority: optional
Maintainer: Debian Tasktools Team <team+tasktools@tracker.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13), cmake, git, python3, bash-completion, asciidoctor
Standards-Version: 4.6.0
Homepage: https://timewarrior.net/
Vcs-Browser: https://salsa.debian.org/tasktools-team/timew
Vcs-Git: https://salsa.debian.org/tasktools-team/timew.git
Rules-Requires-Root: no

Package: timewarrior
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: python3
Recommends: taskwarrior
Description: feature-rich time tracking utility
 Timewarrior is a time tracking utility that offers simple stopwatch features
 as well as sophisticated calendar-based backfill, along with flexible
 reporting.

## timew 1.5.0+ds.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 include (CXXSniffer)
 include (FindAsciidoctor)
 
-set (PROJECT_VERSION "1.4.3")
+set (PROJECT_VERSION "1.5.0")
 
 string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,12 @@
                 Extensions.cpp Extensions.h
                 Interval.cpp   Interval.h
                 IntervalFactory.cpp IntervalFactory.h
+                IntervalFilter.cpp IntervalFilter.h
+                IntervalFilterAndGroup.cpp IntervalFilterAndGroup.h
+                IntervalFilterAllInRange.cpp IntervalFilterAllInRange.h
+                IntervalFilterAllWithIds.cpp IntervalFilterAllWithIds.h
+                IntervalFilterAllWithTags.cpp IntervalFilterAllWithTags.h
+                IntervalFilterFirstOf.cpp IntervalFilterFirstOf.h
                 Journal.cpp    Journal.h
                 Range.cpp      Range.h
                 Rules.cpp      Rules.h
@@ -28,6 +34,7 @@
                 dom.cpp
                 init.cpp
                 helper.cpp
+                paths.cpp      paths.h
                 log.cpp
                 util.cpp
                 validate.cpp)

=== doc/themes/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)

message ("-- Configuring theme documentation")

install (FILES README           DESTINATION ${TIMEW_DOCDIR}/doc/themes)
INSTALL (FILES dark.theme       DESTINATION ${TIMEW_DOCDIR}/doc/themes)
INSTALL (FILES dark_blue.theme  DESTINATION ${TIMEW_DOCDIR}/doc/themes)
INSTALL (FILES dark_green.theme DESTINATION ${TIMEW_DOCDIR}/doc/themes)
INSTALL (FILES dark_red.theme   DESTINATION ${TIMEW_DOCDIR}/doc/themes)

=== debian/changelog ===
timew (1.5.0+ds.1-1ubuntu1) noble; urgency=medium

  [Colin Watson]
  * Fix autopkgtest failure due to stderr output.  (LP: #2043738)

 -- Dan Bungert <daniel.bungert@canonical.com>  Thu, 16 Nov 2023 15:12:16 -0700

timew (1.5.0+ds.1-1) unstable; urgency=medium

  * New upstream version 1.5.0+ds.1
  * d/patches: Refresh patches and add Forwarded option
  * d/control:
    + Added myself as uploaders
    + Bump Standards-Version to 4.6.2 (no changes needed)
  * d/copyright: Update copyrights years

 -- Sebastien Badia <sbadia@debian.org>  Sun, 02 Jul 2023 00:34:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: timew
 Section: utils
 Priority: optional
-Maintainer: Debian Tasktools Team <team+tasktools@tracker.debian.org>
-Uploaders: Gordon Ball <gordon@chronitis.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Tasktools Team <team+tasktools@tracker.debian.org>
+Uploaders: Gordon Ball <gordon@chronitis.net>, Sebastien Badia <sbadia@debian.org>
 Build-Depends: debhelper-compat (= 13), cmake, git, python3, bash-completion, asciidoctor
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://timewarrior.net/
 Vcs-Browser: https://salsa.debian.org/tasktools-team/timew
 Vcs-Git: https://salsa.debian.org/tasktools-team/timew.git

## timew 1.7.1%2Bds.1

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 2.8.12)
+cmake_minimum_required (VERSION 3.8)
 
 message ("-- Configuring documentation")

## timew 1.7.1+ds.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8)
set (CMAKE_CXX_STANDARD 17)
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
set (HAVE_CMAKE true)

project (timew)
include (CXXSniffer)
include (FindAsciidoctor)

set (PROJECT_VERSION "1.7.1")

string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)

message ("-- Looking for SHA1 references")
if (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)
  set (HAVE_COMMIT true)
  execute_process (COMMAND git log -1 --pretty=format:%h
                   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                   OUTPUT_VARIABLE COMMIT)
  configure_file (${CMAKE_SOURCE_DIR}/commit.h.in
                  ${CMAKE_SOURCE_DIR}/commit.h)
  message ("-- Found SHA1 reference: ${COMMIT}")
endif (EXISTS ${CMAKE_SOURCE_DIR}/.git/index)

set (PACKAGE "${PROJECT_NAME}")
set (VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "support@gothenburgbitfactory.org")
set (PACKAGE_NAME "${PACKAGE}")
set (PACKAGE_TARNAME "${PACKAGE}")
set (PACKAGE_VERSION "${VERSION}")
set (PACKAGE_STRING "${PACKAGE} ${VERSION}")
string (TIMESTAMP PACKAGE_DATE "%Y-%m-%d")

if (FREEBSD OR DRAGONFLY)
  set (TIMEW_MANDIR  man                  CACHE STRING "Installation directory for man pages")
  set (TIMEW_MAN1DIR ${TIMEW_MANDIR}/man1 CACHE STRING "Installation directory for man pages, section 1")
  set (TIMEW_MAN5DIR ${TIMEW_MANDIR}/man5 CACHE STRING "Installation directory for man pages, section 5")
  set (TIMEW_MAN7DIR ${TIMEW_MANDIR}/man7 CACHE STRING "Installation directory for man pages, section 7")
else (FREEBSD OR DRAGONFLY)
  set (TIMEW_MANDIR  share/man            CACHE STRING "Installation directory for man pages")
  set (TIMEW_MAN1DIR ${TIMEW_MANDIR}/man1 CACHE STRING "Installation directory for man pages, section 1")
  set (TIMEW_MAN5DIR ${TIMEW_MANDIR}/man5 CACHE STRING "Installation directory for man pages, section 5")
  set (TIMEW_MAN7DIR ${TIMEW_MANDIR}/man7 CACHE STRING "Installation directory for man pages, section 7")
endif (FREEBSD OR DRAGONFLY)
set (TIMEW_DOCDIR share/doc/timew CACHE STRING "Installation directory for doc files")
set (TIMEW_BINDIR bin             CACHE STRING "Installation directory for Timewarrior executable")

message ("-- Configuring cmake.h")
configure_file (${CMAKE_SOURCE_DIR}/cmake.h.in
                ${CMAKE_SOURCE_DIR}/cmake.h)

add_subdirectory (src)
add_subdirectory (src/commands)
add_subdirectory (doc)
add_subdirectory (ext)
if (EXISTS ${CMAKE_SOURCE_DIR}/test)
  add_subdirectory (test EXCLUDE_FROM_ALL)
endif (EXISTS ${CMAKE_SOURCE_DIR}/test)

set (doc_FILES ChangeLog README.md INSTALL AUTHORS LICENSE)
foreach (doc_FILE ${doc_FILES})
  install (FILES ${doc_FILE} DESTINATION ${TIMEW_DOCDIR})
endforeach (doc_FILE)

# ---

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_NAME}-${PACKAGE_VERSION})
set (CPACK_SOURCE_IGNORE_FILES  "CMakeCache"
                                "CMakeFiles"
                                "CPackConfig"
                                "CPackSourceConfig"
                                "_CPack_Packages"
                                "cmake_install"
                                "install_manifest"
                                "Makefile$"
                                "test"
                                "package-config"
                                "src/timew$"
                                "src/libtimew.a"
                                "src/commands/libcommands.a"
                                "src/lex$"
                                "src/liblibshared.a"
                                "/\\\\.gitignore"
                                "/\\\\.git/"
                                "swp$")
include (CPack)

=== ext/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 2.8.12)
+cmake_minimum_required (VERSION 3.8)
 
 message ("-- Configuring extensions")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 2.8.12)
+cmake_minimum_required (VERSION 3.8)
 include_directories (${CMAKE_SOURCE_DIR}
                      ${CMAKE_SOURCE_DIR}/src
                      ${CMAKE_SOURCE_DIR}/src/commands
@@ -14,6 +14,8 @@
                 DatetimeParser.cpp DatetimeParser.h
                 Exclusion.cpp  Exclusion.h
                 Extensions.cpp Extensions.h
+                ExtensionsTable.cpp ExtensionsTable.h
+                GapsTable.cpp GapsTable.h
                 Interval.cpp   Interval.h
                 IntervalFactory.cpp IntervalFactory.h
                 IntervalFilter.cpp IntervalFilter.h
@@ -25,8 +27,11 @@
                 Journal.cpp    Journal.h
                 Range.cpp      Range.h
                 Rules.cpp      Rules.h
+                SummaryTable.cpp SummaryTable.h
+                TagDescription.cpp TagDescription.h
                 TagInfo.cpp    TagInfo.h
                 TagInfoDatabase.cpp TagInfoDatabase.h
+                TagsTable.cpp TagsTable.h
                 Transaction.cpp Transaction.h
                 TransactionsFactory.cpp TransactionsFactory.h
                 UndoAction.cpp UndoAction.h
@@ -65,11 +70,10 @@
 add_executable (timew_executable timew.cpp)
 add_executable (lex_executable   lex.cpp)
 
-target_link_libraries (timew_executable timew libshared commands timew libshared ${TIMEW_LIBRARIES})
-target_link_libraries (lex_executable   timew libshared                libshared ${TIMEW_LIBRARIES})
+target_link_libraries (timew_executable timew commands timew libshared ${TIMEW_LIBRARIES})
+target_link_libraries (lex_executable   timew                libshared ${TIMEW_LIBRARIES})
 
 set_property (TARGET timew_executable PROPERTY OUTPUT_NAME "timew")
 set_property (TARGET lex_executable   PROPERTY OUTPUT_NAME "lex")
 
-install (TARGETS timew_executable DESTINATION bin)
-
+install (TARGETS timew_executable DESTINATION ${TIMEW_BINDIR})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,12 @@
-cmake_minimum_required (VERSION 2.8.12)
+cmake_minimum_required (VERSION 3.8)
 
 # This is a work-around for the following CMake issue:
 # https://gitlab.kitware.com/cmake/cmake/issues/16062
 # The issue has been fixed in CMake 3.11.0; the policy is set
 # to OLD for compatibility with older versions of CMake only.
-if(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
+if (POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
   cmake_policy(SET CMP0037 OLD)
-endif()
+endif ()
 
 # If this is a debug build, check if we have libfiu installed and available on
 # the system. If so, we will be able to use it to add additional tests of the
@@ -38,7 +38,8 @@
 
 add_custom_target (test ./run_all --verbose
                         DEPENDS ${test_SRCS} timew_executable doc
-                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test)
+                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test
+                        COMMENT "Running testsuite...")
 
 foreach (src_FILE ${test_SRCS})
   add_executable (${src_FILE} "${src_FILE}.cpp" test.cpp)

=== doc/holidays/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8)

message ("-- Configuring holiday documentation")

install (FILES README         DESTINATION ${TIMEW_DOCDIR}/holidays)
install (FILES holidays.en-US DESTINATION ${TIMEW_DOCDIR}/holidays)
install (FILES refresh        DESTINATION ${TIMEW_DOCDIR}/holidays)

=== doc/man1/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8)

file (GLOB DOC_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/*.1.adoc")
set (DOC_FILES)

foreach (SRC ${DOC_SOURCES})
  string (REPLACE ".adoc" "" OUTPUT_FILE_NAME "${SRC}")
  string (REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_BINARY_DIR}" OUTPUT_FILE_NAME "${OUTPUT_FILE_NAME}")

  add_custom_command (OUTPUT "${OUTPUT_FILE_NAME}"
                      COMMAND ${ASCIIDOCTOR_EXECUTABLE} -b manpage ${ASCIIDOCTOR_OPTIONS} ${SRC} -o ${OUTPUT_FILE_NAME}
                      DEPENDS "${SRC}")

  set (DOC_FILES ${DOC_FILES} "${OUTPUT_FILE_NAME}")
endforeach (SRC)

add_custom_target (man1 DEPENDS ${DOC_FILES})

install (FILES ${DOC_FILES} DESTINATION ${TIMEW_MAN1DIR})

=== doc/man7/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8)

file (GLOB DOC_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/*.7.adoc")
set (DOC_FILES)

foreach (SRC ${DOC_SOURCES})
  string (REPLACE ".adoc" "" OUTPUT_FILE_NAME "${SRC}")
  string (REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_BINARY_DIR}" OUTPUT_FILE_NAME "${OUTPUT_FILE_NAME}")

  add_custom_command (OUTPUT "${OUTPUT_FILE_NAME}"
                      COMMAND ${ASCIIDOCTOR_EXECUTABLE} -b manpage ${ASCIIDOCTOR_OPTIONS} ${SRC} -o ${OUTPUT_FILE_NAME}
                      DEPENDS "${SRC}")

  set (DOC_FILES ${DOC_FILES} "${OUTPUT_FILE_NAME}")
endforeach (SRC)

add_custom_target (man7 DEPENDS ${DOC_FILES})

install (FILES ${DOC_FILES} DESTINATION ${TIMEW_MAN7DIR})

=== doc/themes/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.8)

message ("-- Configuring theme documentation")

install (FILES README           DESTINATION ${TIMEW_DOCDIR}/themes)
install (FILES dark.theme       DESTINATION ${TIMEW_DOCDIR}/themes)
install (FILES dark_blue.theme  DESTINATION ${TIMEW_DOCDIR}/themes)
install (FILES dark_green.theme DESTINATION ${TIMEW_DOCDIR}/themes)
install (FILES dark_red.theme   DESTINATION ${TIMEW_DOCDIR}/themes)

=== src/commands/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 2.8.12)
+cmake_minimum_required (VERSION 3.8)
 include_directories (${CMAKE_SOURCE_DIR}
                      ${CMAKE_SOURCE_DIR}/src
                      ${CMAKE_SOURCE_DIR}/src/commands
@@ -7,15 +7,14 @@
 
 set (ADDITIONAL_HELP_H "additional-help.h")
 
-ADD_CUSTOM_COMMAND (
-	OUTPUT ${ADDITIONAL_HELP_H}
-	COMMAND /bin/sh src/commands/generate-additional-help.sh > src/commands/${ADDITIONAL_HELP_H}
-	DEPENDS ${CMAKE_CURRENT_LIST_DIR}/generate-additional-help.sh
-	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-	COMMENT "Generating ${ADDITIONAL_HELP_H}")
+add_custom_command (OUTPUT ${ADDITIONAL_HELP_H}
+                    COMMAND /bin/sh src/commands/generate-additional-help.sh > src/commands/${ADDITIONAL_HELP_H}
+                    DEPENDS ${CMAKE_CURRENT_LIST_DIR}/generate-additional-help.sh
+                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+                    COMMENT "Generating ${ADDITIONAL_HELP_H}")
 
-ADD_CUSTOM_TARGET (generate_additional_help
-									 DEPENDS ${ADDITIONAL_HELP_H})
+add_custom_target (generate_additional_help
+                   DEPENDS ${ADDITIONAL_HELP_H})
 
 set (commands_SRCS CmdAnnotate.cpp
                    CmdCancel.cpp
@@ -37,6 +36,7 @@
                    CmdMove.cpp
                    CmdReport.cpp
                    CmdResize.cpp
+                   CmdRetag.cpp
                    CmdStart.cpp
                    CmdStop.cpp
                    CmdSummary.cpp

=== src/libshared/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,8 @@
-cmake_minimum_required (VERSION 2.8)
-set (CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
+cmake_minimum_required (VERSION 3.1)
 set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
 set (HAVE_CMAKE true)
+# https://cmake.org/cmake/help/latest/prop_tgt/CXX_STANDARD.html
+set(CMAKE_CXX_STANDARD 17)
 
 project (shared)
 include (CXXSniffer)
@@ -29,4 +30,3 @@
 if (EXISTS ${CMAKE_SOURCE_DIR}/test)
   add_subdirectory (test EXCLUDE_FROM_ALL)
 endif (EXISTS ${CMAKE_SOURCE_DIR}/test)
-

=== src/libshared/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 2.8)
+cmake_minimum_required (VERSION 3.1)
 include_directories (${CMAKE_SOURCE_DIR}
                      ${CMAKE_SOURCE_DIR}/src)

=== src/libshared/test/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)

# This is a work-around for the following CMake issue:
# https://gitlab.kitware.com/cmake/cmake/issues/16062
# The issue has been fixed in CMake 3.11.0; the policy is set
# to OLD for compatibility with older versions of CMake only.
if(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
  cmake_policy(SET CMP0037 OLD)
endif()

include_directories (${CMAKE_SOURCE_DIR}
                     ${CMAKE_SOURCE_DIR}/src
                     ${CMAKE_SOURCE_DIR}/test
                     ${SHARED_INCLUDE_DIRS})

set (test_SRCS args.t autocomplete.t charliteral.t composite.t color.t configuration.t dates.t datetime.t duration.t external.t format.t fs.t intrinsic.t json.t json_test lexer.t list.t msg.t negative.t palette.t peg.t pig.t plus.t positive.t question.t rx.t sax_test shared.t star.t stringliteral.t table.t timer.t tree.t unicode.t utf8.t)

add_custom_target (test ./run_all --verbose
                        DEPENDS ${test_SRCS}
                        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/test)

foreach (src_FILE ${test_SRCS})
  add_executable (${src_FILE} "${src_FILE}.cpp" test.cpp)
  target_link_libraries (${src_FILE} shared ${SHARED_LIBRARIES})
endforeach (src_FILE)

configure_file(run_all run_all COPYONLY)
configure_file(problems problems COPYONLY)

=== debian/changelog ===
timew (1.7.1+ds.1-2) unstable; urgency=medium

  * Team upload.
  * Run tests with all supported Python3 versions to verify problems with
    non-default Python3 versions
  * Autopkgtest: Restrictions: allow-stderr
    Closes: #1061850 
  * Stop changing shebang in Python3 scripts and add debian/clean to fix
    dh_clean target
    Closes: #1047001

 -- Andreas Tille <tille@debian.org>  Sun, 25 Feb 2024 10:25:40 +0100

timew (1.7.1+ds.1-1) unstable; urgency=medium

  * New upstream version 1.7.1+ds.1
  * d/upstream: Added metadata (UMEGAYA)
  * d/copyright:
    + Added myself
    + Added a comment about tarball repacked
  * d/patches:
    + Refresh patches according new release
    + Remove applied upstream patch
    + Added DEP-3 headers

 -- Sebastien Badia <sbadia@debian.org>  Sat, 27 Jan 2024 22:32:33 +0100

timew (1.5.0+ds.1-2) unstable; urgency=medium

  * d/tests: use mandb -u to avoid extraneous stderr; patch from Colin Watson
    (closes: #1053924)

 -- Gordon Ball <gordon@chronitis.net>  Sat, 20 Jan 2024 21:32:39 +0000

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
TAG_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | tr '~' '.' | sed -e 's/+[dfsg]\+.*//')

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with bash-completion

override_dh_installchangelogs:
	dh_installchangelogs -k ChangeLog

get-orig-source:
	@echo downloading git tag v$(TAG_VERSION)
	git clone -b v$(TAG_VERSION) --depth 1 --recursive https://github.com/GothenburgBitFactory/timewarrior.git
	tar -cJ --wildcards --owner=root --group=root --mode=a+rX --exclude '.git*' -f timew_$(DEB_VERSION_UPSTREAM).orig.tar.xz timewarrior/
	rm -rf timewarrior/

=== debian/tests/control ===
Tests: timewarrior
Depends: @, python3-all, python3-dateutil, man-db
Restrictions: allow-stderr

## timew 1.9.1%2Bds.1

=== src/libshared/test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.1)
+cmake_minimum_required (VERSION 3.10)
 
 # This is a work-around for the following CMake issue:
 # https://gitlab.kitware.com/cmake/cmake/issues/16062

## timew 1.9.1+ds.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.8)
+cmake_minimum_required (VERSION 3.10)
 set (CMAKE_CXX_STANDARD 17)
 set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
 set (HAVE_CMAKE true)
@@ -6,8 +6,9 @@
 project (timew)
 include (CXXSniffer)
 include (FindAsciidoctor)
+include (CheckFunctionExists)
 
-set (PROJECT_VERSION "1.7.1")
+set (PROJECT_VERSION "1.9.1")
 
 string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
 
@@ -45,6 +46,9 @@
 set (TIMEW_DOCDIR share/doc/timew CACHE STRING "Installation directory for doc files")
 set (TIMEW_BINDIR bin             CACHE STRING "Installation directory for Timewarrior executable")
 
+check_function_exists(strlcpy HAVE_STRLCPY)
+check_function_exists(timegm  HAVE_TIMEGM)
+
 message ("-- Configuring cmake.h")
 configure_file (${CMAKE_SOURCE_DIR}/cmake.h.in
                 ${CMAKE_SOURCE_DIR}/cmake.h)
@@ -72,15 +76,21 @@
                                 "CPackSourceConfig"
                                 "_CPack_Packages"
                                 "cmake_install"
+                                "cmake.h$"
+                                "commit.h$"
                                 "install_manifest"
                                 "Makefile$"
-                                "test"
                                 "package-config"
                                 "src/timew$"
                                 "src/libtimew.a"
                                 "src/commands/libcommands.a"
                                 "src/lex$"
+                                "src/libshared.a"
                                 "src/liblibshared.a"
+                                "src/libshared/test"
+                                "/\\\\.pre-commit-config.yaml"
+                                "/\\\\.gitmodules"
+                                "/\\\\.github/"
                                 "/\\\\.gitignore"
                                 "/\\\\.git/"
                                 "swp$")

=== doc/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

message ("-- Configuring documentation")

add_subdirectory (holidays)
add_subdirectory (themes)

if (ASCIIDOCTOR_FOUND)
  set (ASCIIDOCTOR_OPTIONS "--attribute=manmanual=User Manuals"
                           "--attribute=mansource=timew ${PROJECT_VERSION}")
endif (ASCIIDOCTOR_FOUND)

add_subdirectory (man1)
add_subdirectory (man7)

add_custom_target (doc ALL DEPENDS man1 man7)

=== ext/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.8)
+cmake_minimum_required (VERSION 3.10)
 
 message ("-- Configuring extensions")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.8)
+cmake_minimum_required (VERSION 3.10)
 include_directories (${CMAKE_SOURCE_DIR}
                      ${CMAKE_SOURCE_DIR}/src
                      ${CMAKE_SOURCE_DIR}/src/commands

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.8)
+cmake_minimum_required (VERSION 3.10)
 
 # This is a work-around for the following CMake issue:
 # https://gitlab.kitware.com/cmake/cmake/issues/16062

=== doc/holidays/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.8)
+cmake_minimum_required (VERSION 3.10)
 
 message ("-- Configuring holiday documentation")

=== doc/man1/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

if (ASCIIDOCTOR_FOUND)
  file (GLOB DOC_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/*.1.adoc")
  set (DOC_FILES)

  foreach (SRC IN LISTS DOC_SOURCES)
    string (REPLACE ".adoc" "" OUTPUT_FILE_NAME "${SRC}")
    string (REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_BINARY_DIR}" OUTPUT_FILE_NAME "${OUTPUT_FILE_NAME}")

    add_custom_command (OUTPUT "${OUTPUT_FILE_NAME}"
                        COMMAND ${ASCIIDOCTOR_EXECUTABLE} -b manpage ${ASCIIDOCTOR_OPTIONS} "${SRC}" -o "${OUTPUT_FILE_NAME}"
                        DEPENDS "${SRC}")

    list (APPEND DOC_FILES "${OUTPUT_FILE_NAME}")
  endforeach (SRC)

  add_custom_target (man1 DEPENDS ${DOC_FILES})
else (ASCIIDOCTOR_FOUND)
  file (GLOB MAN_PAGES "${CMAKE_CURRENT_SOURCE_DIR}/*.1")
  set (DOC_FILES ${MAN_PAGES})
endif (ASCIIDOCTOR_FOUND)

install (FILES ${DOC_FILES} DESTINATION ${TIMEW_MAN1DIR})

=== doc/man7/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

if (ASCIIDOCTOR_FOUND)
  file (GLOB DOC_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/*.7.adoc")
  set (DOC_FILES)

  foreach (SRC IN LISTS DOC_SOURCES)
    string (REPLACE ".adoc" "" OUTPUT_FILE_NAME "${SRC}")
    string (REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "${CMAKE_CURRENT_BINARY_DIR}" OUTPUT_FILE_NAME "${OUTPUT_FILE_NAME}")

    add_custom_command (OUTPUT "${OUTPUT_FILE_NAME}"
                        COMMAND ${ASCIIDOCTOR_EXECUTABLE} -b manpage ${ASCIIDOCTOR_OPTIONS} "${SRC}" -o "${OUTPUT_FILE_NAME}"
                        DEPENDS "${SRC}")

    list (APPEND DOC_FILES "${OUTPUT_FILE_NAME}")
  endforeach (SRC)

  add_custom_target (man7 DEPENDS ${DOC_FILES})
else (ASCIIDOCTOR_FOUND)
  file (GLOB MAN_PAGES "${CMAKE_CURRENT_SOURCE_DIR}/*.7")
  set (DOC_FILES ${MAN_PAGES})
endif (ASCIIDOCTOR_FOUND)

install (FILES ${DOC_FILES} DESTINATION ${TIMEW_MAN7DIR})

=== doc/themes/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.8)
+cmake_minimum_required (VERSION 3.10)
 
 message ("-- Configuring theme documentation")

=== src/commands/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required (VERSION 3.8)
+cmake_minimum_required (VERSION 3.10)
 include_directories (${CMAKE_SOURCE_DIR}
                      ${CMAKE_SOURCE_DIR}/src
                      ${CMAKE_SOURCE_DIR}/src/commands
@@ -30,9 +30,13 @@
                    CmdGaps.cpp
                    CmdGet.cpp
                    CmdHelp.cpp
+                   CmdImport.cpp
                    CmdJoin.cpp
                    CmdLengthen.cpp
                    CmdModify.cpp
+                   CmdModifyEnd.cpp
+                   CmdModifyRange.cpp
+                   CmdModifyStart.cpp
                    CmdMove.cpp
                    CmdReport.cpp
                    CmdResize.cpp

=== src/libshared/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,10 @@
-cmake_minimum_required (VERSION 3.1)
+cmake_minimum_required (VERSION 3.10)
 set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
 set (HAVE_CMAKE true)
 # https://cmake.org/cmake/help/latest/prop_tgt/CXX_STANDARD.html
 set(CMAKE_CXX_STANDARD 17)
+
+set (CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
 project (shared)
 include (CXXSniffer)
@@ -20,6 +22,7 @@
 set (PACKAGE_STRING "${PACKAGE} ${VERSION}")
 
 check_function_exists(strlcpy HAVE_STRLCPY)
+check_function_exists(timegm  HAVE_TIMEGM)
 
 message ("-- Configuring cmake.h")
 configure_file (

=== debian/changelog ===
timew (1.9.1+ds.1-1) unstable; urgency=medium

  * New upstream version 1.9.1+ds.1
  * Rebase patches
  * Use dh-shell-completions, install zsh, fish completions
  * d/control: standards-version 4.7.2, drop rules-requires-root

 -- Gordon Ball <gordon@chronitis.net>  Sun, 02 Nov 2025 21:44:49 +0100

=== debian/control ===
Source: timew
Section: utils
Priority: optional
Maintainer: Debian Tasktools Team <team+tasktools@tracker.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>, Sebastien Badia <sbadia@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, git, python3, asciidoctor, dh-shell-completions
Standards-Version: 4.7.2
Homepage: https://timewarrior.net/
Vcs-Browser: https://salsa.debian.org/tasktools-team/timew
Vcs-Git: https://salsa.debian.org/tasktools-team/timew.git

Package: timewarrior
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: python3
Recommends: taskwarrior
Description: feature-rich time tracking utility
 Timewarrior is a time tracking utility that offers simple stopwatch features
 as well as sophisticated calendar-based backfill, along with flexible
 reporting.

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,11 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with bash-completion
+	dh $@ --with shell_completions
+
+override_dh_auto_configure:
+	find . -type f -exec sed -i '1s|^#!/usr/bin/env python|#!/usr/bin/python|' {} \;
+	dh_auto_configure
 
 override_dh_installchangelogs:
 	dh_installchangelogs -k ChangeLog

=== debian/tests/control ===
Tests: timewarrior
Depends: @, python3, python3-dateutil, man-db

=== debian/watch ===
# this watchfile will find new releases, but currently doesn't download
# them correctly as a git submodule (src/libshared) is also required

version=4
opts=dversionmangle=auto,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
https://github.com/GothenburgBitFactory/timewarrior/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
